package com.bipt.intelligentapplicationorchestrationservice.mapper;

import com.bipt.intelligentapplicationorchestrationservice.pojo.AlgorithmInfo;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface AlgorithmInfoMapper {
    
    @Select("SELECT * FROM algorithm_info WHERE id = #{id}")
    AlgorithmInfo selectById(Long id);
    
    @Select("SELECT * FROM algorithm_info WHERE algorithm_name = #{algorithmName}")
    AlgorithmInfo selectByName(String algorithmName);
    
    @Select("SELECT * FROM algorithm_info WHERE algorithm_type = #{algorithmType}")
    List<AlgorithmInfo> selectByType(String algorithmType);
    
    @Insert("INSERT INTO algorithm_info(algorithm_name, algorithm_file, algorithm_type, description, created_by, file_size) " +
            "VALUES(#{algorithmName}, #{algorithmFile}, #{algorithmType}, #{description}, #{createdBy}, #{fileSize})")
    @Options(useGeneratedKeys = true, keyProperty = "id")
    int insert(AlgorithmInfo algorithmInfo);
    
    @Update("UPDATE algorithm_info SET algorithm_name = #{algorithmName}, algorithm_file = #{algorithmFile}, " +
            "algorithm_type = #{algorithmType}, description = #{description}, file_size = #{fileSize} " +
            "WHERE id = #{id}")
    int update(AlgorithmInfo algorithmInfo);
    
    @Delete("DELETE FROM algorithm_info WHERE id = #{id}")
    int deleteById(Long id);
} 